--- All of LTH UI is handled here.
-- Don't think anyof this is good practice :)
local LAM = LibStub('LibAddonMenu-1.0')
if (not LAM) then return end
local clr = LUMINARY.color
local SI = LUMINARY.SI

--ZO_TradingHouseMenuBar   --TBD
local function SetupOptionsMenu(index)


    LUMINARY.LOptionsPanel = LAM:CreateControlPanel("Luminary_TH_Options_Settings", clr.colArtifact .. "Luminary" .. clr.colTeal .. "\nTrade History v" .. LUMINARY.version)

    LAM:AddHeader(LUMINARY.LOptionsPanel, "Luminary_TH_Options_Use_Default1", clr.colArtifact .. "Luminary" .. clr.colWhite .. " Trade History Settings")

    LAM:AddCheckbox(LUMINARY.LOptionsPanel, "Enable_Mail_Alerts?", "Enable Mail Alerts? ", "Keep this enabled to receive sold items alerts",
        function() return mLuminarySavedTHVarsNew.Enable_Mail end,
        function(val) mLuminarySavedTHVarsNew.Enable_Mail = val end)

    LAM:AddCheckbox(LUMINARY.LOptionsPanel, "Enable_TradeHouse", "Enable Trade House UI?", "Keep this enabled to show trade history UI",
        function() return mLuminarySavedTHVarsNew.Enable_Trade end,
        function(val) mLuminarySavedTHVarsNew.Enable_Trade = val end)


    LAM:AddCheckbox(LUMINARY.LOptionsPanel, "What_Gold_Display", "Show Price Before Guild Cut", "Enable this to show rounded gold",
        function() return mLuminarySavedTHVarsNew.Pick_Gold end,
        function(val) mLuminarySavedTHVarsNew.Pick_Gold = val end)


    LAM:AddCheckbox(LUMINARY.LOptionsPanel, "ShowSoldAlerts", "Show Item Sold Alerts?", "If something is sold while you're playing you'll be notified. Default is on.",
        function() return mLuminarySavedTHVarsNew.ShowSoldAlert end,
        function(val) mLuminarySavedTHVarsNew.ShowSoldAlert = val end)



    LAM:AddEditBox(LUMINARY.LOptionsPanel, "HowFrequentToUpdate", "Check Guild Update Frequency? ", "Default is 200 seconds, this will check guild sales every x seconds.", false,
        function() return tonumber(mLuminarySavedTHVarsNew.Frequency) end,
        function(val) mLuminarySavedTHVarsNew.Frequency = tonumber(val) end)






    LAM:AddCheckbox(LUMINARY.LOptionsPanel, "SelectTheGuildOnTradeOpen", "Pre-Select Trading Guild?", "Enable this to choose which guild is selected on trading house open.\n\n NOTE: This appears to be a bug in ESO where the UI doesn't update",
        function() return mLuminarySavedTHVarsNew.ShouldSelectDefaultGuild end,
        function(val) mLuminarySavedTHVarsNew.ShouldSelectDefaultGuild = val end)


    LAM:AddEditBox(LUMINARY.LOptionsPanel, "MaxGuildHistoryToSave", "Max Guild History to save" ,"Default is 3,500 if you experience lag, lower it, if not raise it.", false,
        function() return tonumber(mLuminarySavedTHVarsNew.HowMuchHistory) end, function(secs) mLuminarySavedTHVarsNew.HowMuchHistory = tonumber(secs) end)



    LAM:AddEditBox(LUMINARY.LOptionsPanel, "LoadAttemptIntervals", "Load Attempt Frequency (seconds)",
        "No less than 10 seconds", false,
        function() return "15" end, function(secs) mLuminarySavedTHVarsNew.loadInSeconds = secs end)

    LAM:AddHeader(LUMINARY.LOptionsPanel, "InfoAboutLuminary", clr.colArtifact .. "Luminary" .. clr.colWhite .. " This addon is in BETA. \n Please report any bugs you find.")

    LAM:AddHeader(LUMINARY.LOptionsPanel, "ShortcutKeysForTrade", "\n\n\n Type /history for shortcut options")




end


local function SetupTradeHouseMenu()

    LUMINARY.win.Main_Control = LUMINARY.wm:CreateTopLevelWindow("LuminaryTradeHouseAll")
    LUMINARY.win.Main_Control:SetMovable(true)
    LUMINARY.win.Main_Control:SetMouseEnabled(true)
    LUMINARY.win.Main_Control:SetDimensions(800, 750)
    LUMINARY.win.Main_Control:SetHidden(true)
    LUMINARY.win.Main_Control:SetAlpha(1)
    LUMINARY.win.Main_Control:SetResizeHandleSize(MOUSE_CURSOR_RESIZE_NS)
    --  LUMINARY.win.Main_Control:SetAnchor(0,GuiRoot,TOPLEFT, LEFT, BOTTOM - 250)


    LumAllSales = LumUnicorn.LumListView.new(LUMINARY.win.Main_Control, {
        width = 970,
        height = 500,
        left = mLuminarySavedTHVarsNew.TH_x,
        top = mLuminarySavedTHVarsNew.TH_y
    })


    local
    LuminarySendMeGold = CreateControlFromVirtual("SendMeGold" .. "WarningIcon", LUMINARY.win.Main_Control, "ZO_Options_WarningIcon")
    LuminarySendMeGold:SetAnchor(0, LUMINARY.win.Main_Control, 0, LEFT - 40, -25)
    LuminarySendMeGold.tooltipText = "Thanks for all of the gold donations! It really motivates me!   \n\n  IGN: @Awesomebilly (NA server)"




    LUMINARY.win.Main_Control.getAllGuildSalesTex = WINDOW_MANAGER:CreateControl(nil, LUMINARY.win.Main_Control, CT_TEXTURE)
    LUMINARY.win.Main_Control.getAllGuildSalesTex:SetDimensions(60, 60)
    LUMINARY.win.Main_Control.getAllGuildSalesTex:SetAnchor(TOPRIGHT, LUMINARY.win.Main_Control, TOPRIGHT, 0, -5)
    -- lthline.frame:SetAnchor(0, lthline, 0, LEFT, 20)
    LUMINARY.win.Main_Control.getAllGuildSalesTex:SetTexture("/esoui/art/hud/radialicon_addfriend_disabled.dds")
    LUMINARY.win.Main_Control.getAllGuildSalesTex:SetTextureCoords(0, 1, 0, 1)
    LUMINARY.win.Main_Control.getAllGuildSalesTex:SetAlpha(1)

    LUMINARY.win.Main_Control.getAllGuildSalesButton = WINDOW_MANAGER:CreateControl(nil, LUMINARY.win.Main_Control.getAllGuildSalesTex, CT_BUTTON)
    LUMINARY.win.Main_Control.getAllGuildSalesButton:SetAnchorFill(LUMINARY.win.Main_Control.getAllGuildSalesTex)
    LUMINARY.win.Main_Control.getAllGuildSalesButton:SetDimensions(25, 25)
    LUMINARY.win.Main_Control.getAllGuildSalesButton.tooltipText = "Get All Guild Sales!"
    LUMINARY.win.Main_Control.getAllGuildSalesButton:SetHandler("OnClicked", function() LUMINARY.win.Main_Control.LUMtotalRecordHistory:SetText(clr.colRed .. SI.get(SI.TOTALRECORDEDHISTORY)) getAllGuildMemberListings() end)
    LUMINARY.win.Main_Control.getAllGuildSalesButton:SetHandler("OnMouseEnter", function(self)
        LUMINARY.win.Main_Control.getAllGuildSalesTex:SetTexture("/esoui/art/hud/radialicon_addfriend_over.dds")
        LUMINARY:tooltipTextEnter(LUMINARY.win.Main_Control.getAllGuildSalesButton,
            "All Guild Sales.", true)
    end)

    LUMINARY.win.Main_Control.getAllGuildSalesButton:SetHandler("OnMouseExit", function(self)
        LUMINARY:tooltipTextEnter(LUMINARY.win.Main_Control.getAllGuildSalesButton)
        LUMINARY.win.Main_Control.getAllGuildSalesTex:SetTexture("/esoui/art/hud/radialicon_addfriend_disabled.dds")
    end)





    LUMINARY.win.Main_Control.selfSalesTex = WINDOW_MANAGER:CreateControl(nil, LUMINARY.win.Main_Control, CT_TEXTURE)
    LUMINARY.win.Main_Control.selfSalesTex:SetDimensions(50, 50)
    LUMINARY.win.Main_Control.selfSalesTex:SetAnchor(TOPRIGHT, LUMINARY.win.Main_Control, TOPRIGHT, -45, 0)
    -- lthline.frame:SetAnchor(0, lthline, 0, LEFT, 20)
    LUMINARY.win.Main_Control.selfSalesTex:SetTexture("/esoui/art/hud/radialicon_removefriend_disabled.dds")
    LUMINARY.win.Main_Control.selfSalesTex:SetTextureCoords(0, 1, 0, 1)
    LUMINARY.win.Main_Control.selfSalesTex:SetAlpha(1)
    -- LUMINARY.win.Main_Control.RefreshTexture:SetHandler("OnClicked", refreshTotalSales)

    -----
    -- BUTTON
    LUMINARY.win.Main_Control.selfSales = WINDOW_MANAGER:CreateControl(nil, LUMINARY.win.Main_Control.selfSalesTex, CT_BUTTON)
    LUMINARY.win.Main_Control.selfSales:SetAnchorFill(LUMINARY.win.Main_Control.selfSalesTex)
    LUMINARY.win.Main_Control.selfSales:SetDimensions(25, 25)
    --LUMINARY.win.Main_Control.RefreshBtn:SetWidth(100)
    --LUMINARY.win.Main_Control.RefreshBtn:SetText(SI.get(SI.TELEREFRESH))
    LUMINARY.win.Main_Control.selfSales:SetHandler("OnClicked", function()
    LUMINARY.sortByPrice:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_neutral.dds")
    LUMINARY.sortByTime:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_neutral.dds")
    LUMINARY.win.Main_Control.LUMtotalRecordHistory:SetText(clr.colRed .. "Your Sales") getSelfGuildSales()
    end)
    LUMINARY.win.Main_Control.selfSales:SetHandler("OnMouseEnter", function(self)
        LUMINARY.win.Main_Control.selfSalesTex:SetTexture("/esoui/art/hud/radialicon_removefriend_over.dds")
        LUMINARY:tooltipTextEnter(LUMINARY.win.Main_Control.selfSales,
            "Your Sales", true)
    end)

    LUMINARY.win.Main_Control.selfSales:SetHandler("OnMouseExit", function(self)
        LUMINARY:tooltipTextEnter(LUMINARY.win.Main_Control.selfSales)
        LUMINARY.win.Main_Control.selfSalesTex:SetTexture("/esoui/art/hud/radialicon_removefriend_disabled.dds")
    end)






    LUMINARY.win.Main_Control.RefreshTexture = WINDOW_MANAGER:CreateControl(nil, LUMINARY.win.Main_Control, CT_TEXTURE)
    LUMINARY.win.Main_Control.RefreshTexture:SetDimensions(60, 60)
    LUMINARY.win.Main_Control.RefreshTexture:SetAnchor(TOPRIGHT, LUMINARY.win.Main_Control, TOPRIGHT, 0, -35)
    -- lthline.frame:SetAnchor(0, lthline, 0, LEFT, 20)
    LUMINARY.win.Main_Control.RefreshTexture:SetTexture("/esoui/art/hud/radialicon_trade_disabled.dds")
    LUMINARY.win.Main_Control.RefreshTexture:SetTextureCoords(0, 1, 0, 1)
    LUMINARY.win.Main_Control.RefreshTexture:SetAlpha(1)
    -- LUMINARY.win.Main_Control.RefreshTexture:SetHandler("OnClicked", refreshTotalSales)

    LUMINARY.win.Main_Control.RefreshBtn = WINDOW_MANAGER:CreateControl(nil, LUMINARY.win.Main_Control.RefreshTexture, CT_BUTTON)
    LUMINARY.win.Main_Control.RefreshBtn:SetAnchorFill(LUMINARY.win.Main_Control.RefreshTexture)
    LUMINARY.win.Main_Control.RefreshBtn:SetDimensions(25, 25)
    --LUMINARY.win.Main_Control.RefreshBtn:SetWidth(100)
    --LUMINARY.win.Main_Control.RefreshBtn:SetText(SI.get(SI.TELEREFRESH))

    LUMINARY.win.Main_Control.RefreshBtn:SetHandler("OnClicked", function()
        
        LUMINARY.sortByPrice:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_neutral.dds")
        LUMINARY.sortByTime:SetTexture("/esoui/art/miscellaneous/list_sortheader_icon_neutral.dds")
        refreshTotalSales()
    end)
    LUMINARY.win.Main_Control.RefreshBtn:SetHandler("OnMouseEnter", function(self)
        LUMINARY:tooltipTextEnter(LUMINARY.win.Main_Control.RefreshBtn,
            "Your Sales", true)
        LUMINARY.win.Main_Control.RefreshTexture:SetTexture("/esoui/art/hud/radialicon_trade_over.dds")
    end)
    LUMINARY.win.Main_Control.RefreshBtn:SetHandler("OnMouseExit", function(self)
        LUMINARY:tooltipTextEnter(LUMINARY.win.Main_Control.RefreshBtn)
        LUMINARY.win.Main_Control.RefreshTexture:SetTexture("/esoui/art/hud/radialicon_trade_disabled.dds")
    end)

    --------------------------------------------------------------------
    -- SEARCH BUTTON

    LUMINARY.win.Main_Control.Searcher = CreateControlFromVirtual("LUMINARY_SEARCH_EDITBOX", LUMINARY.win.Main_Control, "ZO_DefaultEditForBackdrop")
    LUMINARY.win.Main_Control.Searcher:SetParent(LUMINARY.win.Main_Control)
    --    local BOTTOMz = LUMINARY.win.Main_Control
    LUMINARY.win.Main_Control.Searcher:SetSimpleAnchorParent(15, 25)
    --  LUMINARY.win.Main_Control.Searcher:SetAnchor(BOTTOMLEFT, LUMINARY.win.Main_Control, BOTTOMLEFT, 0, -15)
    LUMINARY.win.Main_Control.Searcher:SetDimensions(200, 25)
    LUMINARY.win.Main_Control.Searcher:SetResizeToFitDescendents(false)
    -- LUMINARY.win.Main_Control.Searcher:SetMouseEnabled(true)
    --  LUMINARY.win.Main_Control.Searcher:SetText("Search..")
    --  LUMINARY.win.Main_Control.Searcher:SetHandler("OnClicked", function()LUMINARY.win.Main_Control.ALERTMAXLIST:SetText("")  end)

    ZO_PreHookHandler(LUMINARY.win.Main_Control.Searcher, "OnTextChanged", function(self) LUMINARY.SearchGuildHistory(LUMINARY.win.Main_Control.Searcher:GetText()) end)

    LUMINARY.win.Main_Control.SearchBG = WINDOW_MANAGER:CreateControlFromVirtual("LUMINARY.win.Main_Control.SearchBG", LUMINARY.win.Main_Control.Searcher, "ZO_DefaultBackdrop")
    LUMINARY.win.Main_Control.SearchBG:ClearAnchors()
    LUMINARY.win.Main_Control.SearchBG:SetAnchorFill(LUMINARY.win.Main_Control.Searcher)
    LUMINARY.win.Main_Control.SearchBG:SetDimensions(LUMINARY.win.Main_Control.Searcher:GetWidth(), LUMINARY.win.Main_Control.Searcher:GetHeight())
    LUMINARY.win.Main_Control.SearchBG.controlType = CT_CONTROL
    LUMINARY.win.Main_Control.SearchBG.system = SETTING_TYPE_UI
    LUMINARY.win.Main_Control.SearchBG:SetHidden(false)
    LUMINARY.win.Main_Control.SearchBG:SetMouseEnabled(false)
    LUMINARY.win.Main_Control.SearchBG:SetMovable(false)

    LUMINARY.win.Main_Control.SearchBG:SetClampedToScreen(true)


    LUMINARY.win.Main_Control.SearchTexture = WINDOW_MANAGER:CreateControl("LUMINARY.win.Main_Contmrol.SearchTexture", LUMINARY.win.Main_Control.SearchBG, CT_TEXTURE)
    -- LUMINARY.win.Main_Control.RefreshTexture:SetAnchorFill(LUMINARY.win.Main_Control.Searcher)
    LUMINARY.win.Main_Control.SearchTexture:SetDimensions(50, 50)
    LUMINARY.win.Main_Control.SearchTexture:SetAnchor(RIGHT, LUMINARY.win.Main_Control.SearchBG, RIGHT, RIGHT + 30, 0)
    LUMINARY.win.Main_Control.SearchTexture:SetTexture("/esoui/art/miscellaneous/search_icon.dds")
    LUMINARY.win.Main_Control.SearchTexture:SetTextureCoords(0, 1, 0, 1)



    --  name .. "_Item"
    LUMINARY.win.Main_Control.SearchTextureBTN = WINDOW_MANAGER:CreateControl(" LUMINARY.win.Main_Control.SearchTextureBTN", LUMINARY.win.Main_Control.SearchTexture, CT_BUTTON)
    LUMINARY.win.Main_Control.SearchTextureBTN:SetFont("ZoFontGame")
    LUMINARY.win.Main_Control.SearchTextureBTN:SetDimensions(25, 25)
   LUMINARY.win.Main_Control.SearchTextureBTN:SetHandler("OnClicked", function()  LUMINARY.SearchGuildHistory(LUMINARY.win.Main_Control.Searcher:GetText()) end)
    LUMINARY.win.Main_Control.SearchTextureBTN:SetAnchorFill(LUMINARY.win.Main_Control.SearchTexture)



    LUMINARY.win.Main_Control.closeTexture = WINDOW_MANAGER:CreateControl(nil, LUMINARY.win.Main_Control, CT_TEXTURE)
    LUMINARY.win.Main_Control.closeTexture:SetDimensions(60, 60)
    LUMINARY.win.Main_Control.closeTexture:SetAnchor(TOPRIGHT, LUMINARY.win.Main_Control, TOPRIGHT, TOPRIGHT + 35, -75)
    LUMINARY.win.Main_Control.closeTexture:SetTexture("/esoui/art/crafting/crafting_smithing_notrait.dds")
    LUMINARY.win.Main_Control.closeTexture:SetTextureCoords(0, 1, 0, 1)
    LUMINARY.win.Main_Control.closeTexture:SetAlpha(0.5)


    LUMINARY.win.Main_Control.closeTexturebutton = WINDOW_MANAGER:CreateControl(nil, LUMINARY.win.Main_Control.closeTexture, CT_BUTTON)
    LUMINARY.win.Main_Control.closeTexturebutton:SetAnchorFill(LUMINARY.win.Main_Control.closeTexture)
    LUMINARY.win.Main_Control.closeTexturebutton:SetDimensions(25, 25)
    LUMINARY.win.Main_Control.closeTexturebutton:SetHandler("OnClicked", function() LUMINARY.HideOnClick() end)
    LUMINARY.win.Main_Control.closeTexturebutton:SetHandler("OnMouseEnter", function(self)
        LUMINARY.win.Main_Control.closeTexture:SetAlpha(1)
        LUMINARY:tooltipTextEnter(LUMINARY.win.Main_Control.closeTexture,
            "Close.", true)
    end)

    LUMINARY.win.Main_Control.closeTexturebutton:SetHandler("OnMouseExit", function(self)
        LUMINARY.win.Main_Control.closeTexture:SetAlpha(0.5)
        LUMINARY:tooltipTextEnter(LUMINARY.win.Main_Control.closeTexture)
    end)


    local
    reopenTradeHistoryz = CreateControlFromVirtual("LTHReopenButton", ZO_TradingHouseLeftPane, "ZO_DefaultButton")
    reopenTradeHistoryz:SetAnchor(BOTTOM)
    reopenTradeHistoryz:SetWidth(200)
    reopenTradeHistoryz:SetText("Luminary " .. SI.get(SI.TRADEHOUSE))
    reopenTradeHistoryz:SetHandler("OnClicked", LUMINARY.ToggleLumTradeHistory)
    --
    --
    --
    local
    LuminaryHeaderTitleWarning = CreateControlFromVirtual("LuminaryHeaderTitleWarning" .. "WarningIcon", LUMINARY.win.Main_Control, "ZO_Options_WarningIcon")
    LuminaryHeaderTitleWarning:SetAnchor(0, LUMINARY.win.Main_Control, 0, LEFT - 40, 80)
    LuminaryHeaderTitleWarning.tooltipText = "@Awesomebilly & @Moosyoolka \n Accepting Guild Applications!\n http://facebook.com/LuminaryGuild"

    --  ------------------- LABELS

    LUMINARY.win.Main_Control.appNameTitlez = LUMINARY.wm:CreateControl("LuminaryTradeHouseHeaderzALL", LUMINARY.win.Main_Control, CT_LABEL)
    LUMINARY.win.Main_Control.appNameTitlez:SetDimensions(600, 30)
    LUMINARY.win.Main_Control.appNameTitlez:SetFont("ZoFontWinH4")
    LUMINARY.win.Main_Control.appNameTitlez:SetAlpha(1)
    LUMINARY.win.Main_Control.appNameTitlez:SetAnchor(0, LUMINARY.win.Main_Control, 0, CENTER + 250, -45)
    LUMINARY.win.Main_Control.appNameTitlez:SetText(clr.colArtifact .. "LUMINARY" .. clr.colWhite .. " TRADE HOUSE")



    LUMINARY.win.Main_Control.LUMtotalRecordHistory = LUMINARY.wm:CreateControl("TotalHistoryz", LUMINARY.win.Main_Control, CT_LABEL)
    LUMINARY.win.Main_Control.LUMtotalRecordHistory:SetDimensions(600, 30)
    LUMINARY.win.Main_Control.LUMtotalRecordHistory:SetFont("ZoFontWinH4")
    LUMINARY.win.Main_Control.LUMtotalRecordHistory:SetAlpha(1)
    LUMINARY.win.Main_Control.LUMtotalRecordHistory:SetAnchor(0, LUMINARY.win.Main_Control, 0, LEFT + 10, -45)
    LUMINARY.win.Main_Control.LUMtotalRecordHistory:SetText(clr.colRed .. "Your Sales")
end

--- - END SetupTradeHouseMenu()


--
function setup_TH_display(index, name)

    SetupOptionsMenu()
    SetupTradeHouseMenu()
end


