function OnAddOnLoaded(eventCode, addOnName)
    if "Luminary_TradeHistory_Sales" ~= addOnName then return end

    local Default = {
        ["ALL_PLAYER_SALES"] = {},
        ['MAX_HISTORY_SHOWN'] = 5,
        ["ALL_GUILD_SALES"] = {},
        ["Enable_Mail"] = true,
        ["Enable_Trade"] = true,
        ["loadInSeconds"] = 15,
        ["Pick_Gold"] = true,
        ["RECORD_ALL_GUILD_SALES"] = false,
        ["TH_x"] = 30,
        ["TH_y"] = 30,
        ["vLog"] = false,
        ["dLog"] = false,
        ["hLog"] = false,
        ["ShouldSelectDefaultGuild"] = false,
        ["WhichGuild"] = 1,
        ["HowMuchHistory"] = 4500,
        ["Frequency"] = 200,
        ["ShowSoldAlert"] = true
    }

    mLuminarySavedTHVarsNew = ZO_SavedVars:NewAccountWide("Luminary_TradeHistory_SV_NEW", 9, nil, Default, nil)


    EVENT_MANAGER:RegisterForEvent(LUMINARY.appName, EVENT_MAIL_OPEN_MAILBOX, LUMINARY.MailBoxIsOpen)
    EVENT_MANAGER:RegisterForEvent(LUMINARY.appName, EVENT_MAIL_CLOSE_MAILBOX, LUMINARY.MailBoxIsClosed)



    EVENT_MANAGER:RegisterForEvent(LUMINARY.appName, EVENT_OPEN_TRADING_HOUSE, LUMINARY.mTradeStoreOpen)
    EVENT_MANAGER:RegisterForEvent(LUMINARY.appName, EVENT_CLOSE_TRADING_HOUSE, LUMINARY.mTradeStoreClosed)
    --  EVENT_MANAGER:RegisterForEvent(LUMINARY.appName, EVENT_GUILD_HISTORY_CATEGORY_UPDATED, mCateogryUpdated)
    --  EVENT_MANAGER:RegisterForEvent(LUMINARY.appName, EVENT_GUILD_HISTORY_RESPONSE_RECEIVED, mResponseRec)
    --  EVENT_MANAGER:RegisterForEvent(LUMINARY.appName, EVENT_GUILD_DATA_LOADED, mGuildDataLoaded)
    EVENT_MANAGER:RegisterForEvent(LUMINARY.appName, EVENT_PLAYER_ACTIVATED, LUMINARY.ForceLoadGuildHistory)
    --    EVENT_MANAGER:RegisterForEvent(LUMINARY.appName, EVENT_TRADING_HOUSE_RESPONSE_RECEIVED, LUMINARY.SelectDefaultGuild)  -- TBD


    setup_TH_display(1, "Luminary_TradeHistory_Sales")
end
